//+=========================================================================================================+\\
//|			Made by..																						|\\
//|		   ____   ____  _				 __	  		  _		   												|\\
//|		  |_  _| |_  _|(_)	      		[  |		/ |_		 											|\\
//| 		\ \   / /  __   .--.   .--.  | |  ,--. `| |-' .--.   _ .--.  									|\\
//| 		 \ \ / /  [  | ( (`\]/ .'`\ \| | `'_\ : | | / .'`\ \[ `/'`\] 									|\\
//| 		  \ ' /    | |  `'.'.| \__. || | // | |,| |,| \__. | | |     									|\\
//|    		   \_/    [___][\__) )'.__.'[___]\'-;__/\__/ '.__.' [___]    									|\\
//|								BL_ID: 20490 | BL_ID: 48980													|\\
//|				Forum Profile(48980): http://forum.blockland.us/index.php?action=profile;u=144888;			|\\
//|																											|\\
//+=========================================================================================================+\\

function findNPLBL_IDByName(%name)
{
	for(%i=0;%i<NPL_List.rowCount();%i++)
	{
		%n = getField(NPL_List.getRowText(%i), 1);
		if(striPos(%n, %name) >= 0)
			return getField(NPL_List.getRowText(%i), 3);
	}
	return -1;
}

function VisoLogger_Add(%server, %bl_id, %name, %message)
{
	%dateStr = getDateTime();
	%date = strReplace(getWord(%dateStr, 0), "/", ".");
	%time = getWord(%dateStr, 1);

	%message = stripMLControlChars(%message);
	%name = stripMLControlChars(%name);

	%server = stripChars(%server, "\"<>=*?:");
	if(trim(%message) $= "")
		return;

	%f = new FileObject(LoggerSO);
	if(%bl_id != -1)
	{
		%f.openForAppend("config/client/Logging/" @ %server @ "/PlayerLog " @ %date @ ".txt");
		%line = %time TAB %name TAB %bl_id TAB %message;
		%chatLine = "(" @ %bl_id @ ") " @ %name @ ": " @ %message;
	}
	else
	{
		%f.openForAppend("config/client/Logging/" @ %server @ "/ChatLog " @ %date @ ".txt");
		%line = "[" @ %time @ "] " @ %message;
		%chatLine = %message;
	}
	%f.writeLine(%line);
	%f.close();
	%f.delete();
	echo(%chatLine);
}

if(isPackage("Viso_Logger"))
	deactivatepackage("Viso_Logger");

package Viso_Logger
{
	function clientCmdChatMessage(%client, %callback, %string, %tagged, %prefix, %name, %suffix, %message) 
	{
		Parent::clientCmdChatMessage(%client, %callback, %string, %tagged, %prefix, %name, %suffix, %message);
		%msg = stripMLControlChars(deTag(%message));
		%name = stripMLControlChars(deTag(%name));
		if(trim(%msg) !$= "")
			VisoLogger_Add($Logger::ServerName, findNPLBL_IDByName(%name), %name, %msg);
	}

	function clientCmdServerMessage(%client, %callback, %string, %tagged, %prefix, %name, %suffix, %message)
	{
		Parent::clientCmdServerMessage(%client, %callback, %string, %tagged, %prefix, %name, %suffix, %message);
		%msg = stripMLControlChars(deTag(%callback));
		if(trim(%msg) !$= "")
			VisoLogger_Add($Logger::ServerName, -1, "", %msg);
	}

	function gameConnection::onConnectionAccepted(%t)
	{
		schedule(0, 0, "Logger_SaveServerName");
		return Parent::onConnectionAccepted(%t);
	}
};
activatePackage("Viso_Logger");

//Thanks Swollow
function Logger_SaveServerName()
{
	$Logger::ServerName = $ServerInfo::Name;
	$Logger::ServerHostName = Logger_getHostName();

	%dateStr = getDateTime();
	%date = strReplace(getWord(%dateStr, 0), "/", ".");
	%time = getWord(%dateStr, 1);

	%server = stripChars($Logger::ServerName, "\"<>=*?:");

	%f = new FileObject(LoggerSO);
	%f.openForAppend("config/client/Logging/" @ %server @ "/ChatLog " @ %date @ ".txt");
	%line = "-------- [" @ %time @ "] You connected to this server. --------";
	%chatLine = %message;
	%f.writeLine(%line);
	%f.close();
	%f.delete();

	%f = new FileObject(LoggerSO);
	%f.openForAppend("config/client/Logging/" @ %server @ "/PlayerLog " @ %date @ ".txt");
	%line = "-------- [" @ %time @ "] You connected to this server. --------";
	%f.writeLine(%line);
	%f.close();
	%f.delete();
}

function Logger_getHostName()
{
	%s = $Logger::ServerName;
	if(%s $= "")
		%s = $ServerInfo::Name;
		
	%a = strPos(%s, "'s");
	%b = strPos(%s, "s'");

	if(%a >= %b)
		%c = %a;
	else
		%c = %b;

	if(%c == -1)
		return "";

	%n = getSubStr(%s, 0, %c);
	return %n;
}